
local pi, rand = math.pi, math.random
local w, h = love.graphics.getDimensions()
local SYSTEMS = 10
local imgData  = love.image.newImageData( h/60, h/60 )
local imgData2 = love.image.newImageData( h/60, h/60 )
for x=0, h/60 - 1 do
	for y=0, h/60 - 1 do
		local halfsize = h/120
		local c = 1-(((halfsize-x)/halfsize)^2+((halfsize-y)/halfsize)^2)^1/2 --pythagorean distance from edge to center, is 0 at edge and 1 at center
		if c<0 then  c=0  end
		imgData  :setPixel( x, y, 255, 255, 255, rand(10)>6 and rand()*80*c or 0 ) -- some magic numbers
		imgData2 :setPixel( x, y, 255, 255, 255, rand(10)>6 and rand()*30*c or 0 )
	end
end
local img  = love.graphics.newImage( imgData )
local img2 = love.graphics.newImage( imgData2 )
local ps = {} -- particlesystems
ps[1] = love.graphics.newParticleSystem( img, w*5 )
ps[1]:setPosition( w*3/4, -w/25 )
ps[1]:setAreaSpread( "uniform", w*0.75, 0 )
ps[1]:setColors( 255, 255, 255, 255 )
ps[1]:setSpeed( h/20, h/5 )
ps[1]:setSpin( 0.1, 0.1 )
ps[1]:setDirection( pi*2/3 )
ps[1]:setLinearAcceleration( -h/60, h/300, -h/86, h/50 )
ps[1]:setTangentialAcceleration( -h/192, h/192 )
ps[1]:setEmissionRate( h/20 )
ps[1]:setParticleLifetime( h/60, h/33 )
ps[1]:start( )
for i=2, SYSTEMS do
	ps[i] = ps[1]:clone()
	ps[i]:setRotation( rand()*2*pi )
end
ps[SYSTEMS]:setSpeed( h/75, h/20 )
ps[SYSTEMS]:setTexture( img2 )


function love.update(dt)
	for _, p in pairs( ps ) do
		p:setDirection( rand( 0.6, 0.8 )*pi )
		p:update( dt )
	end
end


function love.draw()
	for i=1, SYSTEMS-1 do
		love.graphics.draw( ps[i], 0, 0, 0, 2, 4 )
	end
	love.graphics.draw( ps[SYSTEMS], 0, 0, 0, 4, 8 )
end


keys =
{
	escape = love.event.quit
}

function love.keypressed(k)
	local action = keys[k]
	if action then action() end
end
-- vim: set fdm=marker :
